#include <stdio.h>

#define N	5

short matrix[N][N];

void stampa(void)
{
	short i,j,k;

	putchar('\n');
	for(i = 0; i < N; i++) {
		for(j = 0; j < N; j++) {
			putchar('[');
			if(k = matrix[i][j])
				printf("%2hd",k);
			else {
				putchar(' ');
				putchar(' ');
			}
			putchar(']');
		}
		putchar('\n');
	}
}

char checkpos(short x, short y)
{
	return !(x < 0 || x >= N || y < 0 || y >= N || matrix[x][y]); 
}

char backtrack(short x, short y, short n)
{
	short i,xx,yy;
	static short m[][2] = { 1,-2, 2,-1, 2,1, 1,2, -1,2, -2,1, -2,-1, -1,-2 };

	if(n == N * N)
		return 1;
	for(i = 0; i < 8; i++)
		if(checkpos(xx = x + m[i][0], yy = y + m[i][1])) {
			matrix[xx][yy] = n+1;
			if(backtrack(xx,yy,n+1))
				return 1;				
		}
	stampa();
	matrix[x][y] = 0;
	return 0; 
}

int main(void)
{
	short x,y,n;
	
	matrix[x = 0][y = 0] = n = 1;
	if(backtrack(x,y,1))
		stampa();
	putchar('\n');
}
